<p:declare-step xmlns:p="http://www.w3.org/ns/xproc"
                xmlns:ml="http://xmlcalabash.com/ns/extensions/marklogic"
                xmlns:pkg="http://expath.org/ns/pkg"
                xmlns:web="http://expath.org/ns/webapp"
                xmlns:db="http://fgeorges.org/ns/test/database"
                pkg:import-uri="http://expath.org/ns/samples/servlex/hello.xproc"
                name="pipeline"
                version="1.0">

   <p:input port="request"/>

   <p:output port="response">
      <p:inline>
         <web:response status="200" message="Ok">
            <web:body content-type="application/xml"/>
         </web:response>
      </p:inline>
   </p:output>

   <p:output port="response-bodies">
      <p:pipe port="result" step="body"/>
   </p:output>

   <p:xslt name="body">
      <p:input port="source">
         <p:pipe step="pipeline" port="request"/>
      </p:input>
      <p:input port="stylesheet">
         <p:inline>
            <xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                            version="2.0">
               <xsl:template match="web:request">
                  <xsl:variable name="who" select="web:param[@name eq 'who']/@value"/>
                  <xsl:variable name="greetings" select="concat('Hello, ', $who, '!')"/>
                  <html xmlns="http://www.w3.org/1999/xhtml">
                     <head>
                        <title>
                           <xsl:value-of select="$greetings"/>
                        </title>
                     </head>
                     <body>
                        <p>
                           <xsl:value-of select="$greetings"/>
                           <xsl:text> (in XProc)</xsl:text>
                        </p>
                     </body>
                  </html>
               </xsl:template>
            </xsl:stylesheet>
         </p:inline>
      </p:input>
      <p:with-param name="who" select="web:param[@name eq 'who']/@value">
         <p:pipe step="pipeline" port="request"/>
      </p:with-param>
   </p:xslt>

</p:declare-step>
